Index: XIOS/dev/dev_trunk_graph/src/node/grid.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/grid.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/grid.cpp	(revision 2137)
@@ -1210,4 +1210,5 @@
   }
 
+
   void CGrid::sendGridToCouplerOut(CContextClient* client, const string& fieldId)
   {
@@ -1217,4 +1218,5 @@
     distributeGridToServer(client,fieldId) ;
   }
+
 
   void CGrid::distributeGridToServer(CContextClient* client, const string& fieldId)
@@ -1312,5 +1314,5 @@
     CMessage message ;
     if (isCoupling) message<<getCouplingAlias(fieldId) ;
-    else message<<getId() ;
+    else message<<getId() ; 
     gridScattererConnector.transfer(maskOut, client, event, message) ;
     for(auto& it : scattererConnectors) delete it ;
@@ -1342,6 +1344,6 @@
     clientFromServerConnector_[client] = new CGridGathererConnector(clientFromServerConnectors) ;
 
-
-  }
+  }
+
 
   void CGrid::recvMask(CEventServer& event)
@@ -1394,10 +1396,8 @@
   }
 
-
   string CGrid::getCouplingAlias(const string& fieldId)
   {
     return "_grid_of_"+fieldId;
   }
-
 
   void CGrid::makeAliasForCoupling(const string& fieldId)
@@ -1650,9 +1650,6 @@
     std::shared_ptr<CFilter> inputFilter = std::shared_ptr<CPassThroughFilter>(new CPassThroughFilter(gc));
     std::shared_ptr<CFilter> outputFilter = inputFilter ;
-    cout<<"***************CGrid::buildTransformationGraph Pass through filter ***************"<<transformationGoing<<field->getId()<<endl;
-    /*inputFilter->graphEnabled = true;
-    inputFilter->graphPackage = new CGraphPackage;
-    inputFilter->graphPackage->inFields.push_back(field);
-*/
+
+
     string newId ;
     if (gridSrc!=nullptr) newId = gridSrc->getId() + " --> " + this->getId()  ;
@@ -1667,6 +1664,5 @@
     else  
     {
-      StdString role = CXios::isClient? "Client ": "Server ";
-      cout<<role<<"Create new grid : "<<newId<<endl ;
+      cout<<"Create new grid : "<<newId<<endl ;
       newGrid = CGrid::create(newId) ;
       isNewGrid = true ;
@@ -1715,5 +1711,6 @@
         else if (srcElement.type==TYPE_AXIS)   tmpGridSrc->addAxis(srcElement.axis->getId()) ;
         else if (srcElement.type==TYPE_SCALAR) tmpGridSrc->addScalar(srcElement.scalar->getId()) ;
-        tmpGridSrc->checkElementsAttributes() ;
+        // WARNING -> suppress checkElement attribute ? What append ?
+        // tmpGridSrc->checkElementsAttributes() ;
         CGrid* tmpGridDst=CGrid::create(); // destination Grid
         map<int,int> posInGrid={{0,0}} ;
@@ -1956,5 +1953,4 @@
           auxField->getInstantDataFilter()->connectOutput(transformFilter,i) ;
           i++ ;
-          
         }
         outputFilter = transformFilter ;
Index: XIOS/dev/dev_trunk_graph/src/node/grid.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/grid.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/grid.hpp	(revision 2137)
@@ -336,5 +336,5 @@
 
       private:
-        CGridLocalConnector* workflowToModelConnector_ ;
+        CGridLocalConnector* workflowToModelConnector_ = nullptr;
       public:
         void computeWorkflowToModelConnector(void) ;
Index: XIOS/dev/dev_trunk_graph/src/node/interpolate_axis.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/interpolate_axis.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/interpolate_axis.cpp	(revision 2137)
@@ -60,11 +60,32 @@
     }
 
+    if (!this->coordinate.isEmpty() && (!this->coordinate_src.isEmpty() || !this->coordinate_dst.isEmpty()))
+    {
+       ERROR("CInterpolateAxis::checkValid(CAxis* axisSrc)",
+               << "<coordinate> is incompatible with <coordinate_src> or <coordinate_dst> attributes. <coordinate> attribute is present only for backward"
+               << "compatibility and is now declared obsolete") ;
+    }
 
     if (!this->coordinate.isEmpty())
     {
-      StdString coordinate = this->coordinate.getValue();
       if (!CField::has(coordinate))
         ERROR("CInterpolateAxis::checkValid(CAxis* axisSrc)",
                << "Coordinate field whose id " << coordinate << "does not exist "
+               << "Please define one");
+    }
+
+    if (!this->coordinate_src.isEmpty())
+    {
+      if (!CField::has(coordinate_src))
+        ERROR("CInterpolateAxis::checkValid(CAxis* axisSrc)",
+               << "Coordinate field whose id " << coordinate_src << "does not exist "
+               << "Please define one");
+    }
+
+    if (!this->coordinate_dst.isEmpty())
+    {
+      if (!CField::has(coordinate_dst))
+        ERROR("CInterpolateAxis::checkValid(CAxis* axisSrc)",
+               << "Coordinate field whose id " << coordinate_dst << "does not exist "
                << "Please define one");
     }
@@ -74,9 +95,37 @@
   {
     std::vector<StdString> auxInputs;
+    
+    if (!this->coordinate.isEmpty() && (!this->coordinate_src.isEmpty() || !this->coordinate_dst.isEmpty()))
+    {
+       ERROR("std::vector<StdString> CInterpolateAxis::checkAuxInputs_()",
+               << "<coordinate> is incompatible with <coordinate_src> or <coordinate_dst> attributes. <coordinate> attribute is present only for backward"
+               << "compatibility and is now declared obsolete") ;
+    }
+
     if (!this->coordinate.isEmpty())
     {
       StdString coordinate = this->coordinate.getValue();
       if (!CField::has(coordinate))
-        ERROR("CInterpolateAxis::checkValid(CAxis* axisSrc)",
+        ERROR("std::vector<StdString> CInterpolateAxis::checkAuxInputs_()",
+               << "Coordinate field whose id " << coordinate << "does not exist "
+               << "Please define one");
+      auxInputs.push_back(coordinate);
+    }
+
+    if (!this->coordinate_src.isEmpty())
+    {
+      StdString coordinate = this->coordinate_src.getValue();
+      if (!CField::has(coordinate))
+        ERROR("std::vector<StdString> CInterpolateAxis::checkAuxInputs_()",
+               << "Coordinate field whose id " << coordinate << "does not exist "
+               << "Please define one");
+      auxInputs.push_back(coordinate);
+    }
+
+    if (!this->coordinate_dst.isEmpty())
+    {
+      StdString coordinate = this->coordinate_dst.getValue();
+      if (!CField::has(coordinate))
+        ERROR("std::vector<StdString> CInterpolateAxis::checkAuxInputs_()",
                << "Coordinate field whose id " << coordinate << "does not exist "
                << "Please define one");
@@ -97,7 +146,9 @@
                                                         std::map<int, int>& elementPositionInGridDst2DomainPosition)
   {
-    if (!coordinate.isEmpty())  return CAxisAlgorithmInterpolateCoordinate::create(isSource, gridDst,  gridSrc, this, elementPositionInGrid, 
-                                      elementPositionInGridSrc2ScalarPosition, elementPositionInGridSrc2AxisPosition, elementPositionInGridSrc2DomainPosition,
-                                      elementPositionInGridDst2ScalarPosition, elementPositionInGridDst2AxisPosition, elementPositionInGridDst2DomainPosition);
+    if (!coordinate.isEmpty() || !coordinate_src.isEmpty() || !coordinate_dst.isEmpty()) 
+       return CAxisAlgorithmInterpolateCoordinate::create(isSource, gridDst,  gridSrc, this, elementPositionInGrid, 
+              elementPositionInGridSrc2ScalarPosition, elementPositionInGridSrc2AxisPosition, elementPositionInGridSrc2DomainPosition,
+              elementPositionInGridDst2ScalarPosition, elementPositionInGridDst2AxisPosition, elementPositionInGridDst2DomainPosition);
+    
     else return CAxisAlgorithmInterpolate::create(isSource, gridDst,  gridSrc, this, elementPositionInGrid, 
                 elementPositionInGridSrc2ScalarPosition, elementPositionInGridSrc2AxisPosition, elementPositionInGridSrc2DomainPosition,
Index: XIOS/dev/dev_trunk_graph/src/object_factory_impl.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/object_factory_impl.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/object_factory_impl.hpp	(revision 2137)
@@ -149,5 +149,6 @@
    const StdString& CObjectFactory::GetUIdBase(void)
    {
-      static const StdString base = "__"+CObjectFactory::CurrContext + "::" + U::GetName() + "_undef_id_";
+      static StdString base ; 
+      base = "__"+CObjectFactory::CurrContext + "::" + U::GetName() + "_undef_id_";
       return base;
    }
Index: XIOS/dev/dev_trunk_graph/src/test/generic_testcase.f90
===================================================================
--- XIOS/dev/dev_trunk_graph/src/test/generic_testcase.f90	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/test/generic_testcase.f90	(revision 2137)
@@ -113,10 +113,4 @@
   CALL MPI_FINALIZE(ierr)
   
-  if(i_am_server) then
-    print*, "server ",rank, " finished"
-  else
-    print*, "client ",rank, " finished"
-  endif
-
 CONTAINS
 
@@ -368,5 +362,5 @@
     pressure=1e20
     DO j=0,z-1
-      pressure(:,j)=axis_value(j)*100000 ; ! Pa 
+      pressure(:,j)=axis_value(j)*100000 ; ! Pa
       DO i=0,xy-1
         IF (domain_index(i)/=-1) THEN
Index: XIOS/dev/dev_trunk_graph/src/timeline_events.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/timeline_events.hpp	(revision 2137)
+++ XIOS/dev/dev_trunk_graph/src/timeline_events.hpp	(revision 2137)
@@ -0,0 +1,14 @@
+#ifndef __TIMELINE_EVENTS_HPP__
+#define __TIMELINE_EVENTS_HPP__
+
+#include <limits>
+
+namespace xios
+{
+  const size_t timeLineEventbase = std::numeric_limits<size_t>::max()-100 ; 
+  const size_t timelineEventNotifyChangeBufferSize = timeLineEventbase + 0  ; 
+  const size_t timelineEventChangeBufferSize = timeLineEventbase + 1  ; 
+}
+
+
+#endif
Index: XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_extract_domain.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_extract_domain.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_extract_domain.cpp	(revision 2137)
@@ -51,4 +51,5 @@
 TRY
 {
+  axisDestination->checkAttributes() ;
   algo->checkValid(axisDestination, domainSource);
   StdString op = "extract";
Index: XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.cpp	(revision 2137)
@@ -55,6 +55,18 @@
   vector<string> CAxisAlgorithmInterpolateCoordinate::getAuxFieldId(void)
   {
-    if (hasCoordinate_) return vector<string>(1,coordinate_) ;
+    if (hasCoordinateSrc_ && hasCoordinateDest_) return {coordinateSrc_,coordinateDest_} ;
+    else if (hasCoordinateSrc_) return {coordinateSrc_} ;
+    else if (hasCoordinateDest_) return {coordinateDest_} ;
     else return vector<string>() ;
+  }
+  
+  bool CAxisAlgorithmInterpolateCoordinate::transformAuxField(int pos)
+  {
+    if (pos==0)
+    {
+      if (hasCoordinateSrc_) return true ;
+      else if(hasCoordinateDest_) return false ;
+    }
+    if (pos==1) return false ;
   }
 
@@ -69,16 +81,35 @@
     if (!interpAxis->coordinate.isEmpty())
     {
-      coordinate_ = interpAxis->coordinate.getValue();
+      coordinateSrc_ = interpAxis->coordinate.getValue();
       hasCoordinate_=true ;
-    }
-  
-    ngloSrc_=axisSource->n_glo ;
+      hasCoordinateSrc_=true ;
+    }
+
+    if (!interpAxis->coordinate_src.isEmpty())
+    {
+      coordinateSrc_ = interpAxis->coordinate_src.getValue();
+      hasCoordinate_=true ;
+      hasCoordinateSrc_=true ;
+    }
+
+    if (!interpAxis->coordinate_dst.isEmpty())
+    {
+      coordinateDest_ = interpAxis->coordinate_dst.getValue();
+      hasCoordinate_=true ;
+      hasCoordinateDest_=true ;
+    }
+
+    ngloSrc_=axisSource->n_glo ; 
     nDest_ =  axisDest_-> getLocalView(CElementView::WORKFLOW)->getSize() ;
-    CArray<double,1> coord ;
-    CLocalConnector destConnector(axisDest_->getLocalView(CElementView::FULL), axisDest_->getLocalView(CElementView::WORKFLOW)) ;
-    destConnector.computeConnector() ;
-    destConnector.transfer(axisDest_->value, coord) ;
-    destCoordinate_ = vector<double>(coord.dataFirst(), coord.dataFirst()+nDest_) ;
     
+    if (!hasCoordinateDest_)
+    {
+      CArray<double,1> coord ;
+      CLocalConnector destConnector(axisDest_->getLocalView(CElementView::FULL), axisDest_->getLocalView(CElementView::WORKFLOW)) ;
+      destConnector.computeConnector() ;
+      destConnector.transfer(axisDest_->value, coord) ;
+      destCoordinate_ = vector<double>(coord.dataFirst(), coord.dataFirst()+nDest_) ;
+    }
+
     CArray<size_t,1> globalIndex(ngloSrc_) ;
     for(int i=0;i<ngloSrc_;i++) 
@@ -93,4 +124,15 @@
 
     this->computeAlgorithm(axisSource->getLocalView(CElementView::WORKFLOW), axisSourceGlo.getView(CElementView::FULL)) ;
+
+    if (!hasCoordinateSrc_)
+    {
+      CArray<double,1> coord ;
+      CArray<double,1> coordGlo ;
+      CLocalConnector srcConnector(axisSrc_->getLocalView(CElementView::FULL), axisSrc_->getLocalView(CElementView::WORKFLOW)) ;
+      srcConnector.computeConnector() ;
+      srcConnector.transfer(axisSrc_->value, coord) ; // full view value -> workflow value
+      transferTransformConnector_ -> transfer(coord, coordGlo) ; // workflow view -> full global view
+      srcCoordinate_ = vector<double>(coordGlo.dataFirst(), coordGlo.dataFirst()+ngloSrc_) ;
+    }
   }
   CATCH
@@ -98,5 +140,6 @@
   CTransformFilter* CAxisAlgorithmInterpolateCoordinate::createTransformFilter(CGarbageCollector& gc, CGridAlgorithm* algo, bool detectMissingValues, double defaultValue)
   {
-    return new CTransformFilter(gc, 2, algo, detectMissingValues, defaultValue) ;  
+    if (hasCoordinateSrc_ && hasCoordinateDest_) return new CTransformFilter(gc, 3, algo, detectMissingValues, defaultValue) ;
+    else return new CTransformFilter(gc, 2, algo, detectMissingValues, defaultValue) ;  
   }
 
@@ -105,14 +148,20 @@
   {
     CArray<double,1> dataInTmp;
-    CArray<double,1> auxDataInTmp ;
+    CArray<double,1> auxDataInSrc ;
     transferTransformConnector_ -> transfer(dimBefore, dimAfter, dataIn, dataInTmp) ;
-    transferTransformConnector_ -> transfer(dimBefore, dimAfter, auxDataIn[0], auxDataInTmp) ;
-  
+    if (hasCoordinateSrc_)  transferTransformConnector_ -> transfer(dimBefore, dimAfter, auxDataIn[0], auxDataInSrc) ;
+
+   
     dataOut.resize(dimBefore*dimAfter*nDest_) ;
-    const double* pressure = auxDataInTmp.dataFirst() ;
+    const double* pressureSrc ;
+    const double* pressureDest ;
+    if (hasCoordinateSrc_)  pressureSrc = auxDataInSrc.dataFirst() ;
+    if (hasCoordinateDest_ && hasCoordinateSrc_) pressureDest = auxDataIn[1].dataFirst() ;
+    else if (hasCoordinateDest_ && !hasCoordinateSrc_ ) pressureDest = auxDataIn[0].dataFirst() ;
+    
     const double* in = dataInTmp.dataFirst() ;
     double* out = dataOut.dataFirst() ;
 
-    size_t sliceSrc = dimAfter*ngloSrc_ ;
+    size_t sliceSrc  = dimAfter*ngloSrc_ ;
     size_t sliceDest = dimAfter*nDest_ ;
     vector<double> srcCoordinate(ngloSrc_) ;
@@ -123,24 +172,90 @@
     std::vector<int> destIndex(nDest_);
 
-    size_t nsrc ;
+    size_t nsrc, nDest ;
+
     for(size_t j=0, posJsrc=0, posJdest=0 ;  j<dimBefore ; j++, posJsrc+=sliceSrc, posJdest+=sliceDest )
       for(size_t k=0, posKsrc=posJsrc, posKdest=posJdest ; k<dimAfter ; k++, posKsrc++,posKdest++)
       {
-        nsrc=0 ;
-        for(size_t i=0, posIsrc=posKsrc, posIdest=posKdest ; i<ngloSrc_ ; i++, posIsrc+=dimAfter, posIdest+=dimAfter)
-        {
-          if ( !( std::isnan(pressure[posIsrc]) || std::isnan(in[posIsrc]) ) )
-          {
-            srcCoordinate[nsrc]=pressure[posIsrc] ;
-            srcValue[nsrc] = in[posIsrc] ;
-            nsrc++ ;
-          }
-        }
-        destCoordinate = destCoordinate_ ;    
-        computeInterp(nsrc, srcCoordinate, srcValue, srcIndex, nDest_, destCoordinate, destValue, destIndex) ;
-
-        for(size_t i=0, posIdest=posKdest ; i<nDest_ ; i++, posIdest+=dimAfter)  out[posIdest] = destValue[i] ;
+        if (hasCoordinateSrc_)
+        {
+          nsrc=0 ;
+          for(size_t i=0, posIsrc=posKsrc, posIdest=posKdest ; i<ngloSrc_ ; i++, posIsrc+=dimAfter, posIdest+=dimAfter)
+          {
+            if ( !( std::isnan(pressureSrc[posIsrc]) || std::isnan(in[posIsrc]) ) )
+            {
+              srcCoordinate[nsrc]=pressureSrc[posIsrc] ;
+              srcValue[nsrc] = in[posIsrc] ;
+              nsrc++ ;
+            }
+          }
+        }
+        else
+        {
+          nsrc=0 ;
+          for(size_t i=0, posIsrc=posKsrc ; i<ngloSrc_ ; i++, posIsrc+=dimAfter)
+          {
+            if ( !( std::isnan(srcCoordinate_[i]) || std::isnan(in[posIsrc]) ) )
+            {
+              srcCoordinate[nsrc]=srcCoordinate_[i] ;
+              srcValue[nsrc] = in[posIsrc] ;
+              nsrc++ ;
+            }
+          }
+        }  
+
+        if (hasCoordinateDest_)
+        {
+          nDest=0 ;
+          for(size_t i=0, posIdest=posKdest ; i<nDest_ ; i++, posIdest+=dimAfter)
+          {
+            if ( !( std::isnan(pressureDest[posIdest]) ) )
+            {
+              destCoordinate[nDest]=pressureDest[posIdest] ;
+              nDest++ ;
+            }
+          }
+        }
+        else
+        {
+          nDest=0 ;
+          for(size_t i=0, posIdest=posKdest ; i<nDest_ ; i++, posIdest+=dimAfter)
+          {
+            if ( !( std::isnan(destCoordinate[i]) ) )
+            {
+              destCoordinate[nDest]=destCoordinate_[i] ;
+              nDest++ ;
+            }
+          }
+        }
+  
+        computeInterp(nsrc, srcCoordinate, srcValue, srcIndex, nDest, destCoordinate, destValue, destIndex) ;
+        
+        if (hasCoordinateDest_)
+        {
+          nDest=0 ;
+          for(size_t i=0, posIdest=posKdest ; i<nDest_ ; i++, posIdest+=dimAfter)  
+          {
+            if ( !( std::isnan(pressureDest[posIdest]) ) )  
+            {
+              out[posIdest] = destValue[nDest] ;
+              nDest++ ;
+            }
+            else out[posIdest] = std::numeric_limits<double>::quiet_NaN() ;
+          }
+        }
+        else
+        {
+          nDest=0 ;
+          for(size_t i=0, posIdest=posKdest ; i<nDest_ ; i++, posIdest+=dimAfter)  
+          {
+            if ( !( std::isnan(destCoordinate[i]) ) )  
+            {
+              out[posIdest] = destValue[nDest] ;
+              nDest++ ;
+            }
+            else out[posIdest] = std::numeric_limits<double>::quiet_NaN() ;
+          }
+        }
       }
-
   }
 
@@ -176,7 +291,6 @@
             for(int j=lastj; j<nsrc; j++)
             { 
-              if (x >= srcCoordinate[srcIndex[j]] && x<srcCoordinate[srcIndex[j+1]]) ;
               lastj=j ;
-              break ;
+              if (x >= srcCoordinate[srcIndex[j]] && x<srcCoordinate[srcIndex[j+1]]) break ;
             }  
           }
@@ -205,8 +319,6 @@
           for(int j=lastj; j<nsrc; j++)
           { 
-            if (x >= srcCoordinate[srcIndex[j]] && x<srcCoordinate[srcIndex[j+1]]) ;
-            
             lastj=j ;
-            break ;
+            if (x >= srcCoordinate[srcIndex[j]] && x<srcCoordinate[srcIndex[j+1]])  break ;
           }  
         }
Index: XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.hpp	(revision 2137)
@@ -32,4 +32,5 @@
   virtual ~CAxisAlgorithmInterpolateCoordinate() {}
   virtual vector<string> getAuxFieldId(void)  ;
+  virtual bool transformAuxField(int pos) ;
   virtual void apply(int dimBefore, int dimAfter, const CArray<double,1>& dataIn, 
                      const vector<CArray<double,1>>& auxDataIn, CArray<double,1>& dataOut) ;
@@ -44,6 +45,9 @@
   // Interpolation order
   int order_;
-  StdString coordinate_;
+  StdString coordinateSrc_; // pressure src
+  StdString coordinateDest_; // pressure dst
   bool hasCoordinate_=false ;
+  bool hasCoordinateSrc_=false ;
+  bool hasCoordinateDest_=false ;
 
   CAxis* axisSrc_=nullptr ;
@@ -51,5 +55,6 @@
   size_t ngloSrc_ ;
   size_t nDest_ ;
-  vector<double> destCoordinate_ ;
+  vector<double> srcCoordinate_  ; // src axis value
+  vector<double> destCoordinate_ ; // dst axis value
 
 public:
Index: XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_inverse.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_inverse.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/axis_algorithm/axis_algorithm_inverse.cpp	(revision 2137)
@@ -52,4 +52,5 @@
 TRY
 {
+  axisDestination->checkAttributes() ;
   if (axisDestination->n_glo.getValue() != axisSource->n_glo.getValue())
   {
@@ -62,9 +63,8 @@
   auto& transMap = this->transformationMapping_;
 
-  int globalIndexSize = axisSource->index.numElements();
-  for (int idx = 0; idx < globalIndexSize; ++idx)
-  {
-    //transMap[axisDestination->index(idx)] = globalIndexSize-axisDestination->index(idx)-1;
-    transMap[axisSource->index(idx)] = globalIndexSize-axisSource->index(idx)-1;
+  int globalIndexSize = axisDestination->n_glo.getValue();
+  for (int idx = 0; idx < axisDestination->index.numElements(); ++idx)
+  {
+    transMap[axisDestination->index(idx)] = globalIndexSize-axisDestination->index(idx)-1;
   }
 
Index: XIOS/dev/dev_trunk_graph/src/transformation/domain_algorithm/domain_algorithm_reorder.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/domain_algorithm/domain_algorithm_reorder.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/domain_algorithm/domain_algorithm_reorder.cpp	(revision 2137)
@@ -44,11 +44,16 @@
 TRY
 {
+  domainDestination->type.setValue( CDomain::type_attr::rectilinear );
+  domainDestination->ni_glo = domainSource->ni_glo;
+  domainDestination->nj_glo = domainSource->nj_glo;
+  domainDestination->ni = domainSource->ni;
+  domainDestination->nj = domainSource->nj;
+  domainDestination->ibegin = domainSource->ibegin;
+  domainDestination->jbegin = domainSource->jbegin;
+
   reorderDomain->checkValid(domainSource);
-  domainDestination->type = domainSource->type;
-  domainDestination->ni_glo.setValue(domainSource->ni_glo.getValue());
-  domainDestination->nj_glo.setValue(domainSource->nj_glo.getValue());
   domainDestination->checkAttributes() ; // for now but maybe use domainSource as template for domain destination
 
-  if (domainDestination->type !=  CDomain::type_attr::rectilinear)
+  if (domainSource->type !=  CDomain::type_attr::rectilinear)
   {
       ERROR("CDomainAlgorithmReorder::CDomainAlgorithmReorder(CDomain* domainDestination, CDomain* domainSource, CReorderDomain* reorderDomain)",
@@ -65,10 +70,9 @@
   }
   
-  if (!reorderDomain->invert_lat.isEmpty())
+  if (!reorderDomain->invert_lat.isEmpty() && reorderDomain->invert_lat.getValue() )
   {
     CArray<int,1>& j_index=domainDestination->j_index ;
     int nglo = j_index.numElements() ;
     int nj_glo =domainDestination->nj_glo ;
-    
     for (size_t i = 0; i < nglo ; ++i)
     {
@@ -83,5 +87,4 @@
     CArray<int,1>& i_index=domainDestination->i_index ;
     int nglo = i_index.numElements() ;
-    
     for (size_t i = 0; i < nglo ; ++i)
     {
Index: XIOS/dev/dev_trunk_graph/src/transformation/domain_algorithm/domain_algorithm_zoom.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/domain_algorithm/domain_algorithm_zoom.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/domain_algorithm/domain_algorithm_zoom.cpp	(revision 2137)
@@ -95,11 +95,4 @@
   ibeginDest = destIBegin + domainSrc_->ibegin - zoomIBegin_;
   jbeginDest = destJBegin + domainSrc_->jbegin - zoomJBegin_;
-  
-  if (niDest==0) ibeginDest=0 ;
-  if (njDest==0) jbeginDest=0 ;
-    
-  domainDest_->type = domainSrc_ -> type ;
-  domainDest_->data_dim = domainSrc_->data_dim ;
-
   domainDest_->ni_glo.setValue(zoomNi_);
   domainDest_->nj_glo.setValue(zoomNj_);
Index: XIOS/dev/dev_trunk_graph/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/generic_algorithm_transformation.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/generic_algorithm_transformation.hpp	(revision 2137)
@@ -42,5 +42,5 @@
     virtual bool isGenerateTransformation(void) { return false ;}
     virtual StdString getAlgoName() { return "\\nGeneric algorithm transformation";}
-
+    virtual bool transformAuxField(int pos) { return true ;}
     virtual vector<string> getAuxFieldId(void) ;
   protected :
Index: XIOS/dev/dev_trunk_graph/src/transformation/grid_algorithm_generic.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/grid_algorithm_generic.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/grid_algorithm_generic.cpp	(revision 2137)
@@ -64,5 +64,9 @@
 
     gridTransformConnector_->transfer(dataIn, dataOutTmp) ;
-    for (int i=0; i<auxData.size();i++)  gridTransformConnector_->transfer(auxData[i], auxDataOutTmp[i]) ;
+    for (int i=0; i<auxData.size();i++)  
+    {
+      if (algorithm_->transformAuxField(i)) gridTransformConnector_->transfer(auxData[i], auxDataOutTmp[i]) ;
+      else auxDataOutTmp[i].reference(auxData[i]) ;
+    }
 
     algorithm_->apply(dimBefore_, dimAfter_, dataOutTmp, auxDataOutTmp, dataOut) ;
Index: XIOS/dev/dev_trunk_graph/src/transformation/transformation.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/transformation/transformation.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/transformation/transformation.hpp	(revision 2137)
@@ -5,4 +5,5 @@
 #include "xml_node.hpp"
 #include "transformation_enum.hpp"
+#include "exception.hpp"
 
 namespace xios {
